using System;

namespace LambdaCalculus
{
	/// <summary>
	/// A simple Trie data structure which holds Expression objects and indexes them by any ASCII string.
	/// </summary>
	internal class ExpressionTrie
	{
    ExpressionTrie[] oTries;
    Expression oExpression;

		public ExpressionTrie()
		{
		}

    /// <summary>
    /// Get/set the expression in the trie for a specified key.  To undefine a key, set it to null.
    /// </summary>
    public Expression this[string sName]
    {
      get
      {
        return this.Find( sName, 0 );
      }
      set
      {
        this.Insert( sName, 0, value );
      }
    }

    private Expression Find( string sName, int nIndex )
    {
      if (nIndex == sName.Length)
        return this.oExpression.Copy();
      else if (this.oTries == null)
        return null;
      else if (this.oTries[sName[nIndex]] == null)
        return null;
      else
        return this.oTries[sName[nIndex]].Find( sName, nIndex + 1 );
    }

    private void Insert( string sName, int nIndex, Expression oExpression )
    {
      if (nIndex == sName.Length)
      {
        this.oExpression = oExpression;
      }
      else
      {
        if (this.oTries == null)
          this.oTries = new ExpressionTrie[255];
        if (this.oTries[sName[nIndex]] == null)
          this.oTries[sName[nIndex]] = new ExpressionTrie();
        this.oTries[sName[nIndex]].Insert( sName, nIndex + 1, oExpression );
      }
    }
	}
}
