using System;
using System.Collections;

namespace LambdaCalculus
{
	/// <summary>
	/// a hash to store references to identifiers while they are "free" in an expression
	/// </summary>
	internal class IdentifierHash
	{
    private Identifier[] oIdentifiers;
		internal IdentifierHash()
		{
			this.oIdentifiers = new Identifier[26];
		}

    internal Identifier this[char cVariableName]
    {
      get
      {
        return this.oIdentifiers[cVariableName - 97];
      }
      set
      {
        if (this.oIdentifiers[cVariableName - 97] != null) throw new ApplicationException(String.Format( "Cannot define variable '{0}' when '{0}' is a free variable.", cVariableName ));
        this.oIdentifiers[cVariableName - 97] = value;
      }
    }

    internal void Close(char cVariableName)
    {
      this.oIdentifiers[cVariableName - 97] = null;
    }

    internal void Close(Identifier oIdentifier)
    {
      Close(this[oIdentifier]);
    }

    internal char this[Identifier oIdentifier]
    {
      get
      {
        for (int i = 0; i < 26; i++)
        {
          if (this.oIdentifiers[i] == oIdentifier)
          {
            return (char) (i + 97);
          }
        }
        for (int i = 0; i < 26; i++)
        {
          if (this.oIdentifiers[i] == null)
          {
            this.oIdentifiers[i] = oIdentifier;
            return (char) (i + 97);
          }
        }
        throw new ApplicationException(String.Format("No more variable names available."));
      }
    }
	}
}
