using System;

namespace LambdaCalculus
{
  /// <summary>
  /// A simple Trie data structure which holds string objects and indexes them by any ASCII string.
  /// </summary>
  public class StringTrie
  {
    StringTrie[] oTries;
    string sString;

    internal StringTrie()
    {
    }

    /// <summary>
    /// Get/set the string in the trie for a specified key.  To undefine a key, set it to null.
    /// </summary>
    public string this[string sName]
    {
      get
      {
        return this.Find( sName, 0 );
      }
      set
      {
        this.Insert( sName, 0, value );
      }
    }

    private String Find( string sName, int nIndex )
    {
      if (nIndex == sName.Length)
        return this.sString;
      else if (this.oTries == null)
        return null;
      else if (this.oTries[sName[nIndex]] == null)
        return null;
      else
        return this.oTries[sName[nIndex]].Find( sName, nIndex + 1 );
    }

    private void Insert( string sName, int nIndex, string sString )
    {
      if (nIndex == sName.Length)
      {
        this.sString = sString;
      }
      else
      {
        if (this.oTries == null)
          this.oTries = new StringTrie[255];
        if (this.oTries[sName[nIndex]] == null)
          this.oTries[sName[nIndex]] = new StringTrie();
        this.oTries[sName[nIndex]].Insert( sName, nIndex + 1, sString );
      }
    }
  }
}
