using System;

namespace LambdaCalculusGUI
{
	/// <summary>
	/// A class that encapsulates simple functionality for measuring elapsed time within the code.
	/// </summary>
	public class Stopwatch
	{
    /// <summary>
    /// the time at which the stopwatch was last started
    /// </summary>
    private static DateTime oStartTime;

    /// <summary>
    /// Start the stopwatch counting.
    /// </summary>
    public static void Start()
    {
      oStartTime = DateTime.Now;
    }

    /// <summary>
    /// Get the time elapsed since the stopwatch was last started.
    /// </summary>
    /// <returns>the time elapsed since the stopwatch was last started</returns>
    public static TimeSpan ElapsedTime
    {
      get
      {
        return DateTime.Now - oStartTime;
      }
    }
	}
}
